PropertyResource (Apache Ant API)
Description: declaration: package: org.apache.tools.ant.types.resources, class: PropertyResource

# Class PropertyResource

java.lang.Object
org.apache.tools.ant.ProjectComponent
org.apache.tools.ant.types.DataType
org.apache.tools.ant.types.Resource
org.apache.tools.ant.types.resources.PropertyResource

All Implemented Interfaces:
  `Cloneable, Comparable<Resource>, Iterable<Resource>, ResourceCollection`

public class PropertyResource extends Resource
Exposes an Ant property as a Resource.

Since:
  Ant 1.7

- ## Field Summary

  ### Fields inherited from class Resource

  `MAGIC, UNKNOWN_DATETIME, UNKNOWN_SIZE`
  Modifier and Type
  Field
  Description
  `protected static final int`
  `MAGIC`
  Magic number
  `static final long`
  `UNKNOWN_DATETIME`
  Constant unknown datetime for getLastModified
  `static final long`
  `UNKNOWN_SIZE`
  Constant unknown size

  ### Fields inherited from class DataType

  `checked, ref`
  Modifier and Type
  Field
  Description
  `protected boolean`
  `checked`
  Deprecated.
  since 1.7.
  `protected Reference`
  `ref`
  Deprecated.
  since 1.7.

  ### Fields inherited from class ProjectComponent

  `description, location, project`
  Modifier and Type
  Field
  Description
  `protected String`
  `description`
  Deprecated.
  since 1.6.x.
  `protected Location`
  `location`
  Deprecated.
  since 1.6.x.
  `protected Project`
  `project`
  Deprecated.
  since 1.6.x.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `PropertyResource()`
  Default constructor.
  `PropertyResource(Project p, String n)`
  Construct a new PropertyResource with the specified name.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `equals(Object o)`
  Override to implement equality with equivalent Resources, since we are capable of proxying them.
  `InputStream`
  `getInputStream()`
  Get an InputStream for the Resource.
  `Object`
  `getObjectValue()`
  Get the Object value of this PropertyResource.
  `OutputStream`
  `getOutputStream()`
  Get an OutputStream for the Resource.
  `protected PropertyResource`
  `getRef()`
  Perform the check for circular references and return the referenced Resource.
  `protected Resource`
  `getReferencedOrProxied()`
  Get the referenced or proxied Resource, if applicable.
  `long`
  `getSize()`
  Get the size of this Resource.
  `String`
  `getValue()`
  Get the value of this PropertyResource.
  `int`
  `hashCode()`
  Get the hash code for this Resource.
  `boolean`
  `isExists()`
  Find out whether this Resource exists.
  `protected boolean`
  `isReferenceOrProxy()`
  Learn whether this PropertyResource either refers to another Resource or proxies another Resource due to its object property value being said Resource.
  `String`
  `toString()`
  Get the string representation of this Resource.

  ### Methods inherited from class Resource

  `as, asOptional, clone, compareTo, getLastModified, getMagicNumber, getName, isDirectory, isFilesystemOnly, iterator, setDirectory, setExists, setLastModified, setName, setRefid, setSize, size, toLongString`
  Modifier and Type
  Method
  Description
  `<T> T`
  `as(Class<T> clazz)`
  Returns a view of this resource that implements the interface given as the argument or null if there is no such view.
  `<T> Optional<T>`
  `asOptional(Class<T> clazz)`
  Return `Resource.as(Class)` as an `Optional`.
  `Object`
  `clone()`
  Clone this Resource.
  `int`
  `compareTo(Resource other)`
  Delegates to a comparison of names.
  `long`
  `getLastModified()`
  Tells the modification time in milliseconds since 01.01.1970 (the "epoch").
  `protected static int`
  `getMagicNumber(byte[] seed)`
  Create a "magic number" for use in hashCode calculations.
  `String`
  `getName()`
  Name attribute will contain the path of a file relative to the root directory of its fileset or the recorded path of a zip entry.
  `boolean`
  `isDirectory()`
  Tells if the resource is a directory.
  `boolean`
  `isFilesystemOnly()`
  Fulfill the ResourceCollection contract.
  `Iterator<Resource>`
  `iterator()`
  Fulfill the ResourceCollection contract.
  `void`
  `setDirectory(boolean directory)`
  Set the directory attribute.
  `void`
  `setExists(boolean exists)`
  Set the exists attribute.
  `void`
  `setLastModified(long lastmodified)`
  Set the last modification attribute.
  `void`
  `setName(String name)`
  Set the name of this Resource.
  `void`
  `setRefid(Reference r)`
  Overrides the base version.
  `void`
  `setSize(long size)`
  Set the size of this Resource.
  `int`
  `size()`
  Fulfill the ResourceCollection contract.
  `final String`
  `toLongString()`
  Get a long String representation of this Resource.

  ### Methods inherited from class DataType

  `checkAttributesAllowed, checkChildrenAllowed, circularReference, dieOnCircularReference, dieOnCircularReference, dieOnCircularReference, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getDataTypeName, getRefid, invokeCircularReferenceCheck, isChecked, isReference, noChildrenAllowed, pushAndInvokeCircularReferenceCheck, setChecked, tooManyAttributes`
  Modifier and Type
  Method
  Description
  `protected void`
  `checkAttributesAllowed()`
  check that it is ok to set attributes, i.e that no reference is defined
  `protected void`
  `checkChildrenAllowed()`
  check that it is ok to add children, i.e that no reference is defined
  `protected BuildException`
  `circularReference()`
  Creates an exception that indicates the user has generated a loop of data types referencing each other.
  `protected void`
  `dieOnCircularReference()`
  Convenience method.
  `protected void`
  `dieOnCircularReference(Stack<Object> stack, Project project)`
  Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).
  `protected void`
  `dieOnCircularReference(Project p)`
  Convenience method.
  `protected <T> T`
  `getCheckedRef()`
  Deprecated.
  use getCheckedRef(Class)
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName, Project project)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Project p)`
  Deprecated.
  use getCheckedRef(Class)
  `protected String`
  `getDataTypeName()`
  Gets as descriptive as possible a name used for this datatype instance.
  `Reference`
  `getRefid()`
  get the reference set on this object
  `static void`
  `invokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected boolean`
  `isChecked()`
  The flag that is used to indicate that circular references have been checked.
  `boolean`
  `isReference()`
  Has the refid attribute of this element been set?
  `protected BuildException`
  `noChildrenAllowed()`
  Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.
  `static void`
  `pushAndInvokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected void`
  `setChecked(boolean checked)`
  Set the flag that is used to indicate that circular references have been checked.
  `protected BuildException`
  `tooManyAttributes()`
  Creates an exception that indicates that refid has to be the only attribute if it is set.

  ### Methods inherited from class ProjectComponent

  `getDescription, getLocation, getProject, log, log, setDescription, setLocation, setProject`
  Modifier and Type
  Method
  Description
  `String`
  `getDescription()`
  Returns the description of the current action.
  `Location`
  `getLocation()`
  Returns the file/location where this task was defined.
  `Project`
  `getProject()`
  Returns the project to which this component belongs.
  `void`
  `log(String msg)`
  Logs a message with the default (INFO) priority.
  `void`
  `log(String msg, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `setDescription(String desc)`
  Sets a description of the current action.
  `void`
  `setLocation(Location location)`
  Sets the file/location where this task was defined.
  `void`
  `setProject(Project project)`
  Sets the project object of this component.

  ### Methods inherited from class Object

  `finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface Iterable

  `forEach, spliterator`

  ### Methods inherited from interface ResourceCollection

  `isEmpty, stream`
  Modifier and Type
  Method
  Description
  `default boolean`
  `isEmpty()`
  Learn whether this `ResourceCollection` is empty.
  `default Stream<? extends Resource>`
  `stream()`
  Return a `Stream` over this `ResourceCollection`.

- ## Constructor Details

  - ### PropertyResource

    public PropertyResource()
    Default constructor.

  - ### PropertyResource

    public PropertyResource(Project p, String n)
    Construct a new PropertyResource with the specified name.
    Parameters:
      `p` - the project to use.
      `n` - the String name of this PropertyResource (Ant property name/key).

- ## Method Details

  - ### getValue

    public String getValue()
    Get the value of this PropertyResource.
    Returns:
      the value of the specified Property.

  - ### getObjectValue

    public Object getObjectValue()
    Get the Object value of this PropertyResource.
    Returns:
      the Object value of the specified Property.
    Since:
      Ant 1.8.1

  - ### isExists

    public boolean isExists()
    Find out whether this Resource exists.
    Overrides:
      `isExists` in class `Resource`
    Returns:
      true if the Property is set, false otherwise.

  - ### getSize

    public long getSize()
    Get the size of this Resource.
    Overrides:
      `getSize` in class `Resource`
    Returns:
      the size, as a long, 0 if the Resource does not exist (for compatibility with java.io.File), or UNKNOWN_SIZE if not known.

  - ### equals

    public boolean equals(Object o)
    Override to implement equality with equivalent Resources, since we are capable of proxying them.
    Overrides:
      `equals` in class `Resource`
    Parameters:
      `o` - object to compare
    Returns:
      true if equal to o

  - ### hashCode

    public int hashCode()
    Get the hash code for this Resource.
    Overrides:
      `hashCode` in class `Resource`
    Returns:
      hash code as int.

  - ### toString

    public String toString()
    Get the string representation of this Resource.
    Overrides:
      `toString` in class `Resource`
    Returns:
      this Resource formatted as a String.

  - ### getInputStream

    public InputStream getInputStream() throws IOException
    Get an InputStream for the Resource.
    Overrides:
      `getInputStream` in class `Resource`
    Returns:
      an InputStream containing this Resource's content.
    Throws:
      `IOException` - if unable to provide the content of this Resource as a stream.
      `UnsupportedOperationException` - if InputStreams are not supported for this Resource type.

  - ### getOutputStream

    public OutputStream getOutputStream() throws IOException
    Get an OutputStream for the Resource.
    Overrides:
      `getOutputStream` in class `Resource`
    Returns:
      an OutputStream to which content can be written.
    Throws:
      `IOException` - if unable to provide the content of this Resource as a stream.
      `UnsupportedOperationException` - if OutputStreams are not supported for this Resource type.

  - ### isReferenceOrProxy

    protected boolean isReferenceOrProxy()
    Learn whether this PropertyResource either refers to another Resource or proxies another Resource due to its object property value being said Resource.
    Returns:
      boolean

  - ### getReferencedOrProxied

    protected Resource getReferencedOrProxied()
    Get the referenced or proxied Resource, if applicable.
    Returns:
      Resource
    Throws:
      `IllegalStateException` - if this PropertyResource neither proxies nor references another Resource.

  - ### getRef

    protected PropertyResource getRef()
    Description copied from class: `Resource`
    Perform the check for circular references and return the referenced Resource.
    Overrides:
      `getRef` in class `Resource`
    Returns:
      `Resource`.